package org.communiquons.dccaggregator.activities

import android.os.Bundle
import android.util.Log
import android.view.MenuItem
import androidx.appcompat.app.AppCompatActivity
import com.journeyapps.barcodescanner.ScanContract
import com.journeyapps.barcodescanner.ScanOptions
import org.communiquons.dccaggregator.R
import org.communiquons.dccaggregator.databinding.ActivityCertsManagerBinding

class CertsManager : AppCompatActivity() {

    private lateinit var binding: ActivityCertsManagerBinding

    private val TAG = CertsManager::class.java.canonicalName

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityCertsManagerBinding.inflate(layoutInflater)
        setContentView(binding.root)

        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        binding.scanCertButton.setOnClickListener {
            addNewCertificate()
        }
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        if (item.itemId == android.R.id.home) {
            finish()
            return true
        }

        return super.onOptionsItemSelected(item)
    }

    private val barcodeLauncher = registerForActivityResult(ScanContract()) {
        if (it.contents == null)
            return@registerForActivityResult

        Log.v(TAG, it.contents)
    }

    private fun addNewCertificate() {
        barcodeLauncher.launch(ScanOptions().apply {
            setOrientationLocked(true)
            setDesiredBarcodeFormats(ScanOptions.QR_CODE)
            setPrompt(resources.getString(R.string.scan_qr_prompt))
        })
    }
}